Imports System.IO

Public Class ColProcessor
    Private Shared Function Processor(ByVal bLight(,) As Byte)
        Dim bPalette(255, 2) As Byte
        Dim b As Integer = 0
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim x As Integer = 0
        Dim y As Integer = 0
        Dim iMod As Integer = 0
        Dim iGreen As Integer = 0

        While j < 256
            iMod = bLight(j, 1) Mod 8 ' step 1
            For x = 0 To 7
                If iMod = x Then
                    For y = 0 To 3
                        iGreen = y * 64
                        If bLight(j, 0) >= iGreen And bLight(j, 0) < iGreen + 64 Then
                            bPalette(j, 0) = bLight(j, 1) - iMod
                            bPalette(j, 1) = iGreen / 8 + iMod * 32
                            If bLight(j, 0) >= iGreen + 32 Then
                                bPalette(j, 2) = (bLight(j, 0) - iGreen - 32) * 8
                            Else
                                bPalette(j, 2) = (bLight(j, 0) - iGreen) * 8
                            End If
                        End If

                    Next
                End If
            Next
            j = j + 1
        End While

        Return bPalette
    End Function
    Public Shared Function Reader(ByVal filepath As String, ByVal lightindex As Integer)
        Dim bCol(255, 1) As Byte
        Dim fileSize As Integer = FileLen(filepath)
        Dim fsCol As New FileStream(filepath, FileMode.Open, FileAccess.Read)

        fsCol.Seek(lightindex * 512, SeekOrigin.Begin)

        Dim b As Integer = fsCol.ReadByte()     ' Read the byte and store in dummy variable 
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim x As Integer = 0


        For x = 0 To 511
            If i > 1 Then
                i = 0
                j = j + 1
            End If
            bCol(j, i) = b
            b = fsCol.ReadByte()
            i = i + 1
        Next
        fsCol.Close()   ' Done with pcx file
        fsCol.Dispose()

        Dim procPalette(,) As Byte = ColProcessor.Processor(bCol)

        Return procPalette

    End Function
End Class
