﻿Public Class FormBatch

    Private Sub btnExit_Click(sender As System.Object, e As System.EventArgs) Handles btnExit.Click
        Me.Close()
    End Sub

    Private Sub btnBrowse_Click(sender As System.Object, e As System.EventArgs) Handles btnBrowse.Click
        Dim i As Integer = 0
        Dim fileNames1 As String()
        Dim fileNames2 As String()
        Dim fileNames As String()

        FolderBrowserDialog1.RootFolder = Environment.SpecialFolder.Desktop

        FolderBrowserDialog1.Description = "Select Folder Containing CIM Files."

        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then

            fileNames1 = System.IO.Directory.GetFiles(FolderBrowserDialog1.SelectedPath, "*.cim")
            fileNames2 = System.IO.Directory.GetFiles(FolderBrowserDialog1.SelectedPath, "*.pcx")
            ReDim fileNames(fileNames1.Length + fileNames2.Length - 1)
            fileNames1.CopyTo(fileNames, 0)
            fileNames2.CopyTo(fileNames, fileNames1.Length)
            Array.Sort(fileNames)
            dgv.Rows.Clear()

            i = 0
            If fileNames.Length > 0 Then
                While i < fileNames.Length
                    dgv.Rows.Add()
                    dgv.Rows(dgv.Rows.Count - 1).Cells("Filename").Value = System.IO.Path.GetFileName(fileNames(i))
                    i = i + 1
                End While
                lbFolder.Text = FolderBrowserDialog1.SelectedPath
                'checkfiles()
                btnProcess.Enabled = True
            End If

        End If

    End Sub

    Private Sub FormBatch_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        dgv.Columns.Add("Filename", "Filename")
        dgv.Columns.Add("Done", "Done")
    End Sub

    Private Sub btnProcess_Click(sender As System.Object, e As System.EventArgs) Handles btnProcess.Click
        btnExit.Enabled = False
        btnBrowse.Enabled = False
        btnProcess.Enabled = False

        Me.Location = New Drawing.Point(Me.Location.X + Me.Width, Me.Location.Y)
    End Sub
End Class